﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HomeFinance.Model
{
    class MovimentoVirtuale : Movimento
    {
        private readonly IValutatoreScadenza _valutatoreScadenza;
        private readonly IValutatoreImporto _valutatoreImporto;

        public MovimentoVirtuale(Categoria categoria, TipoMovimento tipo, string descrizione, double importo,
            IValutatoreScadenza valutatoreScadenza, IValutatoreImporto valutatoreImporto)
            : base(categoria, tipo, descrizione, importo)
        {
            if (valutatoreScadenza == null)
                throw new ArgumentNullException("valutatoreScadenza");
            if (valutatoreImporto == null)
                throw new ArgumentNullException("valutatoreImporto");
            _valutatoreScadenza = valutatoreScadenza;
            _valutatoreImporto = valutatoreImporto;
        }

        public IValutatoreScadenza ValutatoreScadenza
        {
            get { return _valutatoreScadenza; }
        }

        public IValutatoreImporto ValutatoreImporto
        {
            get { return _valutatoreImporto; }
        }
    }
}
