﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HomeFinance.Model
{
    static class MovimentoVirtualeFactory
    {
        public static MovimentoVirtuale CreateMovimentoUnaTantum(Categoria categoria, TipoMovimento tipo,
            string descrizione, double importo, DateTime dataScadenza)
        {
            return new MovimentoVirtuale(categoria, tipo, descrizione, importo,
                ValutatoreScadenzaFactory.CreatePerScadenzaFissa(dataScadenza),
                ValutatoreImportoFactory.CreatePerImportoCostante());
        }

        public static MovimentoVirtuale CreateMovimentoSettimanaleConCrescitaPercentuale(Categoria categoria, TipoMovimento tipo,
            string descrizione, double importo, DayOfWeek giornoDellaSettimana, double percentuale)
        {
            return new MovimentoVirtuale(categoria, tipo, descrizione, importo,
                ValutatoreScadenzaFactory.CreatePerScadenzaSettimanale(giornoDellaSettimana),
                ValutatoreImportoFactory.CreatePerImportoVariabilePercentuale(percentuale));
        }
    }
}
