﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HomeFinance.Model
{
    static class SelezionatoreBuilder
    {
        public static ISelezionatore Build(IEnumerable<Categoria> categorie = null,
            DateTime dallaData = default(DateTime), DateTime allaData = default(DateTime),
            TipoMovimento tipoMovimento = (TipoMovimento.Ordinario | TipoMovimento.Straordinario))
        {
            ISelezionatore selezionatore = SelezionatoreBase.SelezionatoreDiTutto;
            if (categorie != null)
            {
                selezionatore = new SelezionatorePerCategorie(selezionatore, categorie);
            }
            if (dallaData != default(DateTime))
            {
                selezionatore = new SelezionatoreDallaData(selezionatore, dallaData);
            }
            if (allaData != default(DateTime))
            {
                selezionatore = new SelezionatoreAllaData(selezionatore, allaData);
            }
            if (tipoMovimento == 0)
            {
                return SelezionatoreBase.SelezionatoreDiNiente;
            }
            else if (tipoMovimento != (TipoMovimento.Ordinario | TipoMovimento.Straordinario))
            {
                selezionatore = new SelezionatorePerTipoMovimento(selezionatore, tipoMovimento);
            }
            return selezionatore;
        }
    }
}
