﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HomeFinance.Model
{
    partial class Documento
    {
        private class Selezione : ISelezione
        {
            private ISelezionatore _selezionatore;
            //  Cache
            private IEnumerable<MovimentoReale> _movimenti;

            public event EventHandler Changed;

            public ISelezionatore Selezionatore
            {
                get { return _selezionatore ?? SelezionatoreBase.SelezionatoreDiTutto; }
                set
                {
                    if (value != _selezionatore)
                    {
                        _selezionatore = value;
                        Invalidate();
                    }
                }
            }

            public IEnumerable<MovimentoReale> GetMovimenti()
            {
                if (_movimenti == null)
                {
                    _movimenti = Selezionatore.GetMovimenti();
                }
                return _movimenti;
            }

            public override string ToString()
            {
                return Selezionatore.ToString();
            }

            public void Invalidate()
            {
                _movimenti = null;
                OnChanged();
            }

            private void OnChanged()
            {
                if (Changed != null)
                    Changed(this, EventArgs.Empty);
            }
        }
    }
}