﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using HomeFinance.Model;

namespace HomeFinance.Presentation
{
    public partial class MainForm : Form
    {
        private ISelezione _selezione;
        private TreeViewCategoriePresenter _treeViewCategoriePresenter;

        public MainForm()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            _selezione = Documento.GetInstance().CreateSelezione();
            _treeViewCategoriePresenter = new TreeViewCategoriePresenter(_treeViewCategorie);
            new TreeViewCategoriePresenter(_treeViewCategorieBottom);
            new LabelSelezionePresenter(_label, _selezione);
            new DataGridViewSelezionePresenter(_dataGridView, _selezione);
            new StatusStripSelezionePresenter(_statusStrip, _selezione);
            _treeViewCategoriePresenter.CategoriaCorrenteChanged += Selezione_Changed;
            ModificaSelezionatore();
        }

        private void Selezione_Changed(object sender, EventArgs e)
        {
            ModificaSelezionatore();
        }

        private void ModificaSelezionatore()
        {
            _selezione.Selezionatore = SelezionatoreBuilder.Build(
                categorie: _sottoCategorieToolStripButton.Checked ? _treeViewCategoriePresenter.CategoriaCorrente.GetDescendants(true) :
                    new Categoria[] { _treeViewCategoriePresenter.CategoriaCorrente },
                tipoMovimento: (_ordinariToolStripButton.Checked ? TipoMovimento.Ordinario : 0) |
                               (_straordinariToolStripButton.Checked ? TipoMovimento.Straordinario : 0));
        }

        private void creaMovimentoRealeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Documento.GetInstance().AggiungiMovimentoRealeRandom();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form form = new MainForm();
            form.Show();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}
