﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using HomeFinance.Model;

namespace HomeFinance.Presentation
{
    public class StatusStripSelezionePresenter : SelezionePresenter<StatusStrip>
    {
        public StatusStripSelezionePresenter(StatusStrip statusStrip, ISelezione selezione)
            : base(statusStrip, selezione)
        {
        }

        protected override void InitializeControl()
        {
            Control.Items.Clear();
            foreach (string nomeCalcolo in CalcoloFactory.GetNomi())
            {
                ToolStripStatusLabel statusLabel = new ToolStripStatusLabel(nomeCalcolo);
                statusLabel.Tag = CalcoloFactory.GetCalcolo(nomeCalcolo);
                Control.Items.Add(statusLabel);
            }
        }

        protected override void RefreshControl()
        {
            IEnumerable<MovimentoReale> movimenti = Selezione.GetMovimenti();
            foreach (ToolStripStatusLabel statusLabel in Control.Items)
            {
                ICalcolo calcolo = (ICalcolo) statusLabel.Tag;
                statusLabel.Text = String.Format("{0}: {1:F2} ", calcolo.Nome, calcolo.Calcola(movimenti));
            }
        }
    }
}
